#!/usr/bin/perl
#################################################
#
# D-Link WAP Mac Adder
#
# Written By: John Resig (phytar@csh.rit.edu)
# Date: April 12, 2003
#
# Requirements: LWP Module
#
# For More Information, please visit the
# following web page:
# 	http://csh.rit.edu/~phytar/
#
# This program can be openly distributed and
# edited, as long as it keeps the original
# author and contact information.
#
#################################################

# Hard Coded Defaults
# In order to cut down on typing time, you can
# hard code in as many of the following variables
# as you wish.

# The default Address of your WAP
	$defaultAddress = "";
# The default Administrator's Username
	$defaultUsername = "";
# The default Administrator's Password
	$defaultPassword = "";

if ( $#ARGV < 0 ) {
	&error( "Usage: perl addMac.pl [-a ADDRESS] [-u USERNAME] [-p PASSWORD] MAC
	-a ADDRESS = Overrides the default WAP address
	-u USERNAME = Overrides the default Admin username
	-p PASSWORD = Overrides the default Admin password" );
}

for ( $i = 0; $i <= $#ARGV; $i++ ) {
	if ( $ARGV[ $i ] eq "-a" ) {
		$defaultAddress = $ARGV[ ++$i ];
	} elsif ( $ARGV[ $i ] eq "-u" ) {
		$defaultUsername = $ARGV[ ++$i ];
	} elsif ( $ARGV[ $i ] eq "-p" ) {
		$defaultPassword = $ARGV[ ++$i ];
	} elsif ( $i == $#ARGV ) {
		$mac = $ARGV[ $i ];
	}
}

if ( $defaultAddress eq "" ) {
	&error( "Error: No WAP address specified." );
} elsif ( $defaultUsername eq "" ) {
	&error( "Error: No Admin username specified." );
} elsif ( $defaultPassword eq "" ) {
	&error( "Error: No Admin password specified." );
} elsif ( $mac eq "" ) {
	&error( "Error: You must specify a mac address." );
}

$mac =~ /([\d\w]{2})([\d\w]{2})([\d\w]{2})([\d\w]{2})([\d\w]{2})([\d\w]{2})/i;
$mac1 = $1; $mac2 = $2; $mac3 = $3; $mac4 = $4; $mac5 = $5; $mac6 = $6;

use LWP::UserAgent;

my $ua = LWP::UserAgent->new;
my $req = HTTP::Request->new( GET => "http://" . $defaultAddress . 
	"/mac.cgi?mac1=$mac1\&mac2=$mac2\&mac3=$mac3\&mac4=$mac4\&mac5=$mac5\&mac6=$mac6" );
$req->authorization_basic( $defaultUsername, $defaultPassword );
$ua->request( $req );

sub error {
	print $_[ 0 ] . "\n";
	exit( 0 );
}